-- kb_input.vhd
--
-- lab "Digitaltechnik"
--
-- (c) M. Winzker, Hochschule Bonn-Rhein-Sieg, 06.05.2016

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity kb_input is
    Port ( clk    : in  std_logic;
           reset  : in  std_logic;
           kbdata : in  std_logic;
           kbclk  : in  std_logic;
           byte   : out std_logic_vector(7 downto 0);
           valid  : out std_logic);
end kb_input;

architecture behave of kb_input is

    signal kbclk_q1  : std_logic;
    signal kbclk_q2  : std_logic;
    signal count_int : unsigned(3 downto 0);

begin

    process
    begin
        wait until rising_edge(clk);
        
        if (reset = '1') then
            kbclk_q1  <= '1'; -- signal is '1' during inactive period
            kbclk_q2  <= '1'; -- signal is '1' during inactive period

            count_int <= (others => '0');
            byte      <= (others => '0');
            valid     <= '0';
        else
            kbclk_q1  <= kbclk;
            kbclk_q2  <= kbclk_q1;

            valid     <= '0'; -- default;

            if kbclk_q1 = '1' and kbclk_q2 = '0' then
                -- rising edge
                count_int <= count_int + 1;

                if    count_int = 0  then
                    -- start
                elsif count_int = 1  then
                    -- bit 0
                    byte(0)  <= kbdata;
                elsif count_int = 2  then
                    -- bit 1
                    byte(1)  <= kbdata;
                elsif count_int = 3  then
                    -- bit 2
                    byte(2)  <= kbdata;
                elsif count_int = 4  then
                    -- bit 3
                    byte(3)  <= kbdata;
                elsif count_int = 5  then
                    -- bit 4
                    byte(4)  <= kbdata;
                elsif count_int = 6  then
                    -- bit 5
                    byte(5)  <= kbdata;
                elsif count_int = 7  then
                    -- bit 6
                    byte(6)  <= kbdata;
                elsif count_int = 8  then
                    -- bit 7
                    byte(7)  <= kbdata;
                elsif count_int = 9  then
                    -- parity
                elsif count_int = 10 then
                    -- stop
                    count_int <= (others => '0');
                    valid <= '1';
                end if;
            end if;

		end if;
	end process;

end;

